/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Pangkat;
import com.portofolio.entity.vo.PangkatId;

@Lazy
@Repository("pangkatDao")
public interface PangkatDao extends CrudRepository<Pangkat, PangkatId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaPangkat like %:namaPangkat% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaPangkat") String namaPangkat, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdPangkat = :kdPangkat")
	Map<String, Object> findByKdPangkat(@Param("kdProfile") Integer kdProfile,@Param("kdPangkat") Integer kdPangkat, @Param("statusEnabled") boolean statusEnabled);

	String QListAll = "select new map(model.id.kdPangkat as kdPangkat,model.id.kdProfile as kdProfile "
			+ ", model.namaPangkat as namaPangkat " + ", model.reportDisplay as reportDisplay "
			+ ", model.noUrut as noUrut "  + ", model.kdPangkatHead as kdPangkatHead "
			+ ", pangkatHead.namaPangkat as namaPangakatHead " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal  "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec,model.version as version )"
			+ " from Pangkat model left join model.id id " + " left join model.pangkatHead pangkatHead "
			+ "  where id.kdProfile=:kdProfile and model.statusEnabled =:statusEnabled ";

}
